using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	class ColliderDebug : MonoBehaviour
    {
        void Update()
        {
            foreach (Collider2D coller in gameObject.GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coller); //Instance.AddComponent<ColliderDebug>(); (add this to instances)
            }
        }
    }
    public class Mod
    {
        public static void Main()
        {	
		    CategoryBuilder.Create("[AR] The British Empire/UK", "UK.", ModAPI.LoadSprite("UK.png"));
		    CategoryBuilder.Create("[AR] American Revolutionaries", "USA.", ModAPI.LoadSprite("USA.png"));
		    CategoryBuilder.Create("[AR] American Loyalists", "US-UK.", ModAPI.LoadSprite("USL.png"));
		    CategoryBuilder.Create("[AR] Equipment", "Shared by all nations.", ModAPI.LoadSprite("M.png"));

			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Civilian #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Basic dude idk.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Loyalists"),
                    ThumbnailOverride = ModAPI.LoadSprite("min1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("min1.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Civilian #2",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Basic dude idk.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Loyalists"),
                    ThumbnailOverride = ModAPI.LoadSprite("min2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("min2.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Civilian #3",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Basic dude idk.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Loyalists"),
                    ThumbnailOverride = ModAPI.LoadSprite("min3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("min3.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Soldier (Marine/Buff colour)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("marin.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("marin.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Officer (Marine/Buff colour)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Officer During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("marinO.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("marinO.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Soldier (8th Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("1775.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("1775.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Officer (8th Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Officer During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("1775-officer.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("1775-officer.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Soldier (54th Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("54.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("54.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Officer (54th Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British officer During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("54O.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("54O.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Soldier (33rd Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("33rd.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("33rd.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] British Officer (33rd Regiment of Foot)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "British Officer During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("33rdO.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("33rdO.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Soldier (1778)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA1.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Soldier (Winter-1778)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA6.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Rifleman (1778)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA5.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA5.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Militia #1 (1775-7)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA2.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Militia #2 (1775-7)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA3.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "[AR] Continental Militia #3 (1775-7)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "United States Army Soldier During the American Revolution.",
                    CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                    ThumbnailOverride = ModAPI.LoadSprite("USA4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("USA4.png");
						var flesh = ModAPI.LoadTexture("flesh.png");
						var bone = ModAPI.LoadTexture("bone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 12);
                    }
                }
            );
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Cartridge Box Belting",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Belting.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("Belt_TopO.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_Mid.png", 12f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_TopO.png", 12f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

                        var among3 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_Low.png", 12f);
                        among3.transform.localPosition = (Instance.transform.position);
                        var mogus3 = among3.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus3);
                        among3.FixColliders();
                        ArmorBehaviour armor4 = among3.AddComponent<ArmorBehaviour>();
                        armor4.stabResistance = 0.5f;
                        armor4.armorPiece = "LowerBody"; 
                        armor4.armorTier = 1;
				    }
                }
            );
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Cartridge Box and Bayonet Belting",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Belting.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("Belt_Top.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_Mid.png", 12f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_Top.png", 12f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

                        var among3 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Belt_Low.png", 12f);
                        among3.transform.localPosition = (Instance.transform.position);
                        var mogus3 = among3.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus3);
                        among3.FixColliders();
                        ArmorBehaviour armor4 = among3.AddComponent<ArmorBehaviour>();
                        armor4.stabResistance = 0.5f;
                        armor4.armorPiece = "LowerBody"; 
                        armor4.armorTier = 1;
				    }
                }
            );
			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] British Knapsack",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "Belting.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("Haver_Top.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Haver_Low.png", 12f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Haver_Top.png", 12f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );

			ModAPI.Register(	
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Canteen Belting",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "You need some water bruv.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("Can_Top.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
						//mid
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Can_Mid.png", 12f); //file and scale
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.stabResistance = 0.5f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 1;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0f;
                        Instance.FixColliders();

                        var among2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                        among2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Can_Top.png", 12f);
                        among2.transform.localPosition = (Instance.transform.position);
                        var mogus2 = among2.GetComponent<Collider2D>();
                        GameObject.Destroy(mogus2);
                        among2.FixColliders();
                        ArmorBehaviour armor3 = among2.AddComponent<ArmorBehaviour>();
                        armor3.stabResistance = 0.5f;
                        armor3.armorPiece = "UpperBody"; 
                        armor3.armorTier = 1;

				    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Basic British Cocked Hat",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The Standard issue Hat that the British Army used.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("HatB1.png", 19f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HatB1.png", 19f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Basic British Cocked Hat (Added Stuff)",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The Standard issue Hat that the British Army used.",
                    CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                    ThumbnailOverride = ModAPI.LoadSprite("HatB2.png", 19f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("HatB2.png", 19f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Basic Cocked Hat",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The Standard issue Hat that the Continental Army used.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("Hat1.png", 19f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hat1.png", 19f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Brown Cocked Hat",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "The Standard issue Hat that the Continental Army used.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("Hat2.png", 19f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hat2.png", 19f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Brown Basic Hair #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Baichair1.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Baichair1.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Brown Basic Hair #2",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Baichair3.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Baichair3.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Black Basic Hair #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Baichair2.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Baichair2.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Black Basic Hair #2",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Baichair4.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Baichair4.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Brown-Sideburn #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/sideburn1.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/sideburn1.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Black-Sideburn #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/sideburn2.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/sideburn2.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Stubble #1",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Stub1.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Stub1.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "[AR] Stubble #2",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "hair.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("hair/Stub2.png", 12f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hair/Stub2.png", 12f);
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"),
                NameOverride = "[AR] 1770-Pattern Brown-Bess Musket",
                NameToOrderByOverride = "M1 Garand 2",
                DescriptionOverride = "Musket",
                CategoryOverride = ModAPI.FindCategory("[AR] The British Empire/UK"),
                ThumbnailOverride = ModAPI.LoadSprite("Weapons/Brown_Bess.png", 21f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Brown_Bess.png", 21f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.80f, 0.1400f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 2f;
                    customCartridge.StartSpeed *= 0.8f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 45f;
                    customCartridge.ImpactForce *= 0.8f;
                    firearm.Cartridge = customCartridge;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("Musk.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"),
                NameOverride = "[AR] Basic Charleville Musket",
                NameToOrderByOverride = "M1 Garand 2",
                DescriptionOverride = "French and American Musket",
                CategoryOverride = ModAPI.FindCategory("[AR] American Revolutionaries"),
                ThumbnailOverride = ModAPI.LoadSprite("Weapons/Char.png", 21f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/Char.png", 21f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.80f, 0.1400f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 2f;
                    customCartridge.StartSpeed *= 0.8f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 45f;
                    customCartridge.ImpactForce *= 0.8f;
                    firearm.Cartridge = customCartridge;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("Muskc.mp3"),
                    };

                }
            }
            ); ;
             ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"),
                NameOverride = "[AR] Basic Flint-lock Pistol",
                NameToOrderByOverride = "M1 Garand 2",
                DescriptionOverride = "guh",
                CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                ThumbnailOverride = ModAPI.LoadSprite("Weapons/flin.png", 21f),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Weapons/flin.png", 21f);
                    var firearm = Instance.GetComponent<FirearmBehaviour>();
                    Cartridge customCartridge = ModAPI.FindCartridge("30-06 Springfield");
                    Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.80f, 0.1400f);
                    firearm.casingPosition = new Vector3(-0.250f,0.100f);
                    customCartridge.name = "30-06 Springfield";
                    customCartridge.Damage *= 0.8f;
                    customCartridge.StartSpeed *= 0.8f;
                    customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                    customCartridge.Recoil *= 25f;
                    customCartridge.ImpactForce *= 0.5f;
                    firearm.Cartridge = customCartridge;
                    Instance.FixColliders();
                    firearm.ShotSounds = new AudioClip[]
                    {
                            ModAPI.LoadSound("Flint.mp3"),
                    };

                }
            }
            ); ;
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "[AR] Sabre (Saber)",
                    DescriptionOverride = "its long.",
                    CategoryOverride = ModAPI.FindCategory("[AR] Equipment"),
                    ThumbnailOverride = ModAPI.LoadSprite("weapons/Eng_Sab.png", 25f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/Eng_Sab.png", 25f);
                    }
                }
            );
        }
    }
}


